#include "omp.h"
#include <stdio.h>
#include <string.h>

int main( int argc, char *argv[])
{
  int num_threads;
  
  if ((argc>2) && (0==strcmp(argv[1], "-mt"))) {
    num_threads = atoi( argv[2]);
  }
  else {
    num_threads = 1;
  }
  omp_set_num_threads(num_threads);

  printf( "Starting execution with %d threads:\n",
          omp_get_num_threads());

  #pragma omp parallel
  {
    printf( "Hello world says thread %d.\n", 
            omp_get_thread_num());
  }

  printf( "Execution of %d threads terminated.\n", 
          omp_get_num_threads());
  
  return( 0);
}
